﻿using UnityEngine;
using HarmonyLib;

public class HideHelmet : Mod
{
    public static bool HideLocalModel = true;
    public static bool HideRemoteModel = false;
    public static bool HideOfOtherPlayers = false;

    Harmony harmony;

    public void Start()
    {
        harmony = new Harmony("com.xargoth.HideHelmet");
        harmony.PatchAll();
        Debug.Log("Mod HideHelmet has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);
        Debug.Log("Mod HideHelmet has been unloaded!");
    }

    static bool ExtraSettingsAPI_Loaded = false;

    public void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();

    public void ExtraSettingsAPI_SettingsClose()
    {
        HideLocalModel = ExtraSettingsAPI_GetCheckboxState("hideLocalModel");
        HideRemoteModel = ExtraSettingsAPI_GetCheckboxState("hideRemoteModel");
        HideOfOtherPlayers = ExtraSettingsAPI_GetCheckboxState("hideOfOtherPlayers");
    }

    public bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;
}

[HarmonyPatch(typeof(Equipment_Hat), "SetModelState")]
public class Patch_ValidTarget
{
    static void Postfix(Equipment_Hat __instance)
    {
        if (__instance == null || __instance is Equipment_HeadLight || __instance is Equipment_AnglerfishHead)
        {
            return;
        }

        var playerNetwork = Traverse.Create(__instance).Field("playerNetwork").GetValue<Network_Player>();
        if (playerNetwork == null)
        {
            return;
        }

        var isLocalPlayer = playerNetwork.IsLocalPlayer;
        if (isLocalPlayer && HideHelmet.HideLocalModel)
        {
            var localModel = Traverse.Create(__instance).Field("localModel").GetValue<Transform>();
            localModel?.gameObject.SetActive(false);
        }

        if (isLocalPlayer && HideHelmet.HideRemoteModel || (!isLocalPlayer && HideHelmet.HideOfOtherPlayers))
        {
            var remoteModel = Traverse.Create(__instance).Field("remoteModel").GetValue<Transform>();
            remoteModel?.gameObject.SetActive(false);
            playerNetwork.currentModel.ActivateHairStyle(HairStyle.Full, true);
        }
    }
}
